﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;

namespace WpfApplication1
{
    public enum Pol
    {
        musko,
        zensko
    }

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        
        StreamReader srF = new StreamReader(Properties.Settings.Default.streamPathFudbal);
        StreamReader srK = new StreamReader(Properties.Settings.Default.streamPathKosarka);

        List<Sportista> svi;
        List<Fudbaler> fudbaleri;
        List<Kosarkas> kosarkasi;

        public MainWindow()
        {
            InitializeComponent();
            fudbaleri = new List<Fudbaler>();
            kosarkasi = new List<Kosarkas>();
            svi = new List<Sportista>();

            comboSort.Items.Add("Sortiraj po indexu kjorisnosti");
            comboSort.Items.Add("Kosarkasice i fudbalerke");
            comboSort.Items.Add("Fudbaleri mladji od 20 godina prema broju golova");
            
            
        }

        private void btnUcitajKosarka_Click(object sender, RoutedEventArgs e)
        {
            Kosarkas kosarkas;
            string prvi = srK.ReadLine();
            string regBr;
            string ime;
            string prezime;
            string dat;
            string pol;
            string[] datPom;
            int year;
            int month;
            int day;
            DateTime datum;
            Pol polKosarkasa;
            //lstbKosarka.Items.Add(prvi);

            while (!srK.EndOfStream)
            {
                string str = srK.ReadLine();
                string[] stringovi = str.Split(',');

                regBr = stringovi[0];
                ime = stringovi[1];
                prezime = stringovi[2];
                dat = stringovi[3];
                pol = stringovi[7];

                datPom = dat.Split('.');
                year = int.Parse(datPom[2]);
                month = int.Parse(datPom[1]);
                day = int.Parse(datPom[0]);

                datum = new DateTime(year, month, day);

                if (pol == "m")
                {
                   polKosarkasa = Pol.musko;
                }
                else
	            {
                    polKosarkasa = Pol.zensko;
	            }

                kosarkas = new Kosarkas(regBr,ime,prezime,datum,polKosarkasa,int.Parse(stringovi[5]),int.Parse(stringovi[4]),int.Parse(stringovi[6]));
                lstbKosarka.Items.Add(kosarkas.ToString());
                
            }
            srK.Close();

        }

        private void btnUcitajFudbal_Click(object sender, RoutedEventArgs e)
        {
            Fudbaler fudbaler;

            string prviF = srF.ReadLine();
            string regBrF;
            string imeF;
            string prezimeF;
            string datF;
            string polF;
            string[] datPomF;
            int yearF;
            int monthF;
            int dayF;
            DateTime datumF;
            Pol polFudbalera;

            while (!srF.EndOfStream)
            {
                string str = srF.ReadLine();
                string[] stringoviF = str.Split(',');

                regBrF = stringoviF[0];
                imeF = stringoviF[1];
                prezimeF = stringoviF[2];
                datF = stringoviF[3];
                polF = stringoviF[6];

                datPomF = datF.Split('.');
                yearF = int.Parse(datPomF[2]);
                monthF = int.Parse(datPomF[1]);
                dayF = int.Parse(datPomF[0]);

                datumF = new DateTime(yearF, monthF, dayF);

                if (polF == "m")
                {
                    polFudbalera = Pol.musko;
                }
                else
                {
                    polFudbalera = Pol.zensko;
                }

                fudbaler = new Fudbaler(regBrF, imeF, prezimeF, datumF, polFudbalera, int.Parse(stringoviF[5]), int.Parse(stringoviF[4]));
                lstbFudbal.Items.Add(fudbaler.ToString());

            }

            srF.Close();

          
        }


       
    }
}
