﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kolokvijum
{
    public delegate bool UslovSelekcije(Object o);
    public delegate bool UslovSortiranja(Object o, Object o1);

    public class Lista<T> where T : IUporediv<T>
    {
        public T vrednost;
        public Lista<T> sledeci = null;

        public Lista(T vrednost)
        {
            this.vrednost = vrednost;
        }

        public void Add(T next)
        {
            int ind = 0;
            Lista<T> temp = sledeci;

            foreach (T item in vratiEnumerator())
            {
                if (next.Uporedi(item))
                    ind = 1;
            }

            if (ind == 0)
            {
                while (temp.sledeci != null)
                    temp = sledeci;

                temp.sledeci = new Lista<T>(next);
            }
        }

        public Lista<T> this[int index]
        {
            get
            {
                int i = 0;

                Lista<T> temp = null;

                while (i < index)
                {
                    temp = sledeci;
                    i++;
                }
                return temp;

            }
        }

        public IEnumerable<T> vratiEnumerator()
        {
            Lista<T> temp = sledeci;
            while (temp != null)
            {
                temp = sledeci;
                yield return vrednost;
            }
        }

        public IEnumerable<T> VratiEnumeratorPremaSelekciji(UslovSelekcije u)
        {
            foreach (T item in vratiEnumerator())
            {
                if (u(item))
                    yield return item;
            }
        }

        /*public Lista<T> VratiSortiranuListu(UslovSortiranja us)
        {
            Lista<T> sort = new Lista<T>(vrednost);

            foreach (T item in vratiEnumerator())
            {
                if (us(this, item))
                    sort.sledeci = new Lista<T>();
            }
        }*/

        public override string ToString()
        {
            return vrednost.ToString();
        }

    }
}
