﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Dusan_Zvkovic_56_12
{
    public delegate bool UslovSelekcije<T>(T o);
    public delegate bool UslovSortiranja<T>(T a, T b);

    public class Lista<T> where T : IUporediv<T>
    {
        Lista<T> sledeci;
        public T vrednost;

        public Lista(T glava)
        {
            this.sledeci = null;
            vrednost = glava;
        }
        public bool Add(T vr)
        {

            Lista<T> p = this;
            int pos = 0;
            while (p != null)
            {
                T a = p.vrednost;
                if (a.Uporedi(vr))
                    pos = 1;
                p = p.sledeci;
            }
            if (pos == 0)
            {
                p = this;
                while (p.sledeci != null)
                {

                    p = p.sledeci;
                }
                Lista<T> novi = new Lista<T>(vr);
                p.sledeci = novi;
                novi.sledeci = null;
                return true;
            }
            else
            {
                return false;

            }
        }
        public T this[int index]
        {
            get
            {
                Lista<T> pom;
                pom = this;
                int l = 0;
                while (pom != null)
                {
                    if (l == index)
                        return pom.vrednost;
                    pom = pom.sledeci;
                    l++;
                }
                return default(T);
            }
        }
        public IEnumerable<T> Prolaz()
        {
            Lista<T> pom;
            pom = this;
            while (pom != null)
            {
                yield return pom.vrednost;
                pom = pom.sledeci;
            }
        }
        public IEnumerable<T> VratiEnumeratorPremaSelekciji(UslovSelekcije<T> u)
        {
            Lista<T> pom;
            pom = this;
            while (pom != null)
            {
                if(u(pom.vrednost))
                    yield return pom.vrednost;
                pom = pom.sledeci;
            }
        }
        /*public Lista<T> VratiSortiranuListu(UslovSortiranja<T> uslov)
        {
            Lista<T> nova;
            Lista<T> kopija;
            Lista<T> pom;
            pom = this;
            kopija = new Lista<T>(pom.vrednost);
            pom = pom.sledeci;
            Lista<T> pret = null;
            while (pom != null)
            {
                kopija.Add(pom.vrednost);
            }
            while (kopija.sledeci != null)
            {

                if (uslov(kopija.vrednost, kopija.sledeci.vrednost) == false)
                {
                    Lista<T> a = kopija.sledeci.sledeci;
                    kopija.sledeci = kopija;
                    kopija.sledeci = a;

                }
                pret = kopija;

            }

            return nova;
        }*/


        public override string ToString()
        {
            string s = "";
            Lista<T> pom = this;
            while (pom != null)
            {
                s += pom.vrednost  + " ";
                pom = pom.sledeci;
            }
            return s;           
        }
    }
}
