﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FilipTubic7812
{
    public delegate bool uslovSelekcije<T> ( T tip);
    public delegate bool uslovSortiranja<T> ( T tip1, T tip2);
    public class Lista<T> 
        where T : IUpotrebiv<T>
    {
        public T elem;
        public Lista<T> next = null;

        public Lista(T elem)
        {
            this.elem = elem;
        }
        public bool Add(T elem)
        {
            Lista<T> pom = this;
            Lista<T> prev = null;

            while (pom != null)
            {
                if (pom.elem.Uporedi(elem))
                {
                    return false;
                }
                prev = pom;
                pom = pom.next;
            }

            Lista<T> temp = new Lista<T>(elem);
            prev.next = temp;

            return true;
        }

        public int length
        {
            get
            {
                Lista<T> pom = this;
                int brojac = 0;
                while (pom != null)
                {
                    brojac++;
                    pom = pom.next;
                }
                return brojac;
            }
        }

        public Lista<T> this[int index]{
            get
            {
                int brojac = 0;
                Lista<T> pom = this;
                while (pom != null)
                {
                    if (brojac == index)
                        return pom;
                    brojac++;
                    pom = pom.next;
                }

                return default(Lista<T>);
            }
        }

        public IEnumerable<T> VratiEnumerator(uslovSelekcije<T> uslov)
        {
            Lista<T> pom = this;
            
            while(pom!=null){
                if (uslov(pom.elem))
                    yield return pom.elem;

                pom = pom.next;
            }
        }

        public IEnumerable<T> prodjiKrozListu(uslovSelekcije<T> uslov)
        {
            return this.VratiEnumerator(uslov);
        }

        //public Lista<T> VratiSortiranuListu(uslovSortiranja<T> uslov)
        //{
        //    Lista<T> novaLista = this;

        //    for (int i = 0; i < novaLista.length - 1; i++)
        //    {
        //        for (int j = i + 1; j < novaLista.length; j++)
        //        {
        //            if (uslov(novaLista[i].elem,novaLista[j].elem))
        //            {
        //                Lista<T> t = novaLista[i];
        //                novaLista[i].elem = novaLista[j].elem;
        //                novaLista[i].next = novaLista[j].next;
        //                novaLista[j] = t;
        //            }
        //        }


        //    }
        //    return novaLista;
        //}


        public override string ToString()
        {
            string s="";
            Lista<T> pom = this;
            while (pom != null)
            {
                s = s + pom.ToString();
                pom = pom.next;
            }

            return s;
        }
    }
}
