﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Kolokvijum
{

    public class Lista<T> where T : IUporediv<T>
    {
        public delegate bool UslovSelekcije(T element);
        public delegate bool UslovSortiranja(T element1, T element2);

        T vrednost;
        Lista<T> sledeci;

        public Lista(T vred)
        {
            vrednost = vred;
            sledeci = null;
        }

        public void Add(T element)
        {
            Lista<T> pom = this;

            while (pom.sledeci != null)
            {
                if (pom.vrednost.Uporedi(element))
                    return;

                pom = pom.sledeci;
            }

            pom.sledeci = new Lista<T>(element);
        }

        public T this[int indeks]
        {
            get
            {
                int dokle = 0;
                Lista<T> pom = this;

                while (pom != null)
                {
                    if (indeks == dokle)
                        return pom.vrednost;

                    dokle++;
                    pom = pom.sledeci;
                }

                return default(T);
            }
        }

        public IEnumerable<T> vratiSve()
        {
            Lista<T> pom = this;

            while (pom != null)
            {
                yield return pom.vrednost;
                pom = pom.sledeci;
            }
        }

        public IEnumerable<T> VratiEnumeratorPremaSelekciji(UslovSelekcije u)
        {
            foreach(T element in vratiSve())
            {
                if (u(element) == true)
                    yield return element;
            }
        }

        //public List<T> VratiSortiranuListu()
    }
}
