﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DrugiKolokvijum
{
    public delegate bool UslovSelekcije<T>(T element);
    public delegate bool UslovSortiranja<T>(T element1,T element2);
    public class Lista<T>:IEnumerable<T> where T:IUporediv<T>
    {
        private T glava;
        private Lista<T> sledeci;

        public Lista<T> Sledeci
        {
            get
            {
                return sledeci;
            }
        }

        public T Glava
        {
            get
            {
                return glava;
            }
        }

        public Lista(T glavni)
        {
            this.glava = glavni;
            sledeci = null;
        }

        public void Add(T element)
        {
            Lista<T> trenutni=this;
            while (trenutni!=null)
            {
                if (trenutni.Glava.Uporedi(element)) return;
                if (trenutni.Sledeci == null) break;
                trenutni = trenutni.Sledeci;
            }
            trenutni.sledeci =new Lista<T>(element);
        }

        public T this[int index]
        {
            get
            {
                Lista<T> trenutni=this;
                while (index>0)
                {
                    trenutni = trenutni.sledeci;
                    index--;
                }
                return trenutni.Glava;
            }
        }

        public IEnumerable<T> VratiEnumeratorPremaSelekciji(UslovSelekcije<T> f)
        {
            List<T> vrati = new List<T>();
            foreach (T item in this)
            {
                if (f(item))
                    vrati.Add(item);
            }
            return vrati;
        }

       /* public IEnumerable<T> VratiSortiranuListu(UslovSortiranja<T> f)
        {
            List<T> vrati = new List<T>();
            foreach (T item in this)
            {
                
            }
        }*/

        public IEnumerator<T> GetEnumerator()
        {
            foreach (T item in this)
            {
                yield return item;
            }
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            throw new NotImplementedException();
        }

        public override string ToString()
        {
            string vraca = "";
            foreach (T item in this)
            {
                vraca += item.ToString() + "\n";
            }
            return vraca;
        }
    }
}
