﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SportApp
{
    public class Kosarkas<T>:Sportista<T>
    {
        private int brojAsistencija;
        private int brojPoena;
        private int brojSkokova;

        public Kosarkas(string registracioniBroj, string ime, string prezime, DateTime datumRodjenja, Pol pol, int brojAsistencija, int brojPoena, int brojSkokova)
            : base(registracioniBroj, ime, prezime, datumRodjenja, pol)
        {
            this.brojAsistencija = brojAsistencija;
            this.brojPoena = brojPoena;
            this.brojSkokova = brojSkokova;
        }

        public int BrojAsistencija
        {
            get
            {
                return brojAsistencija;
            }
        }

        public int BrojPoena
        {
            get
            {
                return brojPoena;
            }
        }

        public int BrojSkokova
        {
            get
            {
                return brojSkokova;
            }
        }

        public override int IndexKorisnosti
        {
            get
            {
                return BrojAsistencija + BrojAsistencija + BrojPoena;
            }
            set
            {
                base.IndexKorisnosti = value;
            }
        }

        public override string ToString()
        {
            return base.ToString() + " poeni = " +BrojPoena+ " asistencije = " +BrojAsistencija + " skokovi = " +brojSkokova;
        }
    }
}
