﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SportApp
{
    public enum Pol
    {
        Muski,
        Zenski
    }

    public class Sportista<T>:IEnumerable<T>,IUporedivo<T>
    {
        private string registracioniBroj;
        private string ime;
        private string prezime;
        private DateTime datumRodjenja;
        private Pol pol;

        public string RegistracioniBroj 
        {
            get
            {
                return registracioniBroj;
            }
        }

        public string Ime
        {
            get
            {
                return ime;
            }
        }

        public string Prezime
        {
            get
            {
                return prezime;
            }
        }

        public DateTime DatumRodjenja
        {
            get
            {
                return datumRodjenja;
            }
        }

        public Pol Pol
        {
            get
            {
                return pol;
            }
        }

        public Sportista(string registracioniBroj, string ime, string prezime, DateTime datumRodjenja, Pol pol)
        {
            this.registracioniBroj = registracioniBroj;
            this.ime = ime;
            this.prezime = prezime;
            this.datumRodjenja = datumRodjenja;
            this.pol = Pol;
        }

        public virtual int IndexKorisnosti { get; set; }

        public override string ToString()
        {
            return IndexKorisnosti + " " + Ime + " " +Prezime+ " " + DatumRodjenja.ToString();
        }

        public bool Uporedi(IEnumerable<T> tip)
        {
            Sportista<T> sportista;
            sportista = tip as Sportista<T>;

            if (sportista != null)
            {
                if (this.RegistracioniBroj == sportista.RegistracioniBroj)
                {
                    return true;
                }
            }

            return false;
        }

        public IEnumerator<T> GetEnumerator()
        {
            throw new NotImplementedException();
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            throw new NotImplementedException();
        }
    }
}